


function ChangeDispatcher()
{
	var self = this;
	
	self.listeners = new Array();
	
	
	
	self.addChangeListener = function(component, changeHandler)
	{
		var listener = new Object();
		listener.component = component;
		listener.changeHandler = changeHandler;
		
    	self.listeners.push(listener);
	}
	
	
	self.removeChangeListener = function(component)
	{
		for (var i = 0; i < self.listeners.length; i++)
		{
			if (self.listeners[i].component == component)
				self.listeners.splice(i, 1);
			
			// was self.listeners.splice(self.listeners.indexOf(listener), 1);
		}
	}
	
	
	self.broadcastChange = function(change)
	{
		for (var i = 0; i < self.listeners.length; i++)
		{
			self.listeners[i].changeHandler(change);
		}
	}
}

